<?php

/**
 *
 * mpath-tools - failover and load balancing between multiple ISP made easy
 * 
 * Copyright (C) 2008-2010 Vincent Negrier aka. sIX <six at aegis-corp.org>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 *
 * @package mpath-tools
 * @subpackage tools
 */

namespace MPath_Tools;

function getopt($format) {

	// Like PHP getopt() but adds "?" and "-" format option, also supports optional parameters "x::"
	
	global $argc, $argv;
	
	$ret = $opts = array();

	// Parse format
	
	$fl = strlen($format);
	
	for ($i = 0; $i < $fl; $i++) {

		$opt_char = $format[$i];

		if ($format[$i + 1] === ":") {

			if ($format[$i + 2] === ":") {

				$opt_type = 2;

			} else {

				$opt_type = 1;

			}

		} else {

			$opt_type = 0;

		}

		$i += $opt_type;

		$opts[$opt_char] = $opt_type;

	}
	
	// Parse args
	
	for ($i = 1; $i < $argc; $i++) {

		$arg = $argv[$i];

		if ($arg[0] === "-") {

			if (isset($opts[$arg[1]])) {

				$opt_key = $arg[1];
				
				switch ($opts[$arg[1]]) {

					case 0:
					$opt_val = false;
					break;

					case 1:
					
					if (strlen($arg) > 2) {

						$opt_val = substr($arg, 2);
					
					} else {
					
						$opt_val = $argv[++$i];

					}

					break;

					case 2:

					if (strlen($arg) > 2) {

						$opt_val = substr($arg, 2);

					} else if ($argv[$i + 1][0] !== "-") {

						$opt_val = $argv[++$i];

					} else {

						$opt_val = false;

					}

					break;
				
				}

			} else {

				$opt_key = "?";
				$opt_val = $arg;
			
			}
		
		} else {

			$opt_key = "-";
			$opt_val = $arg;
			
		}

		if (isset($opts[$opt_key])) {
		
			if (isset($ret[$opt_key])) {

				if (!is_array($ret[$opt_key])) $ret[$opt_key] = array($ret[$opt_key]);

				$ret[$opt_key][] = $opt_val;

			} else {

				$ret[$opt_key] = $opt_val;

			}
	
		}
	
	}
	
	return $ret;

}

?>