var xhr = false;
var gwstats = [];
var display_probe = [];
var display_traffic = [];

function mp_init() {

	init_display_options();
	update_display_options();
	commit_display_options();
	update_values();

}

function init_display_options() {

	var tmp = document.getElementsByTagName("span");

	for (i = 0; i < tmp.length; i++) {

		if (tmp[i].className == "display_options") {

			var gw_id = tmp[i].getAttribute("data-gw");
			var opt = tmp[i].getAttribute("data-opt");

			if (display_probe[gw_id] == null)
				if (window.default_display_probe == null)
					display_probe[gw_id] = true;
				else
					display_probe[gw_id] = window.default_display_probe;
			
			if (display_traffic[gw_id] == null)
				if (window.default_display_traffic == null)
					display_traffic[gw_id] = false;
				else
					display_traffic[gw_id] = window.default_display_traffic;

			tmp[i].onclick = function() { toggle_display_option(this.getAttribute("data-gw"), this.getAttribute("data-opt")); };

		}

	}

}

function update_display_options() {

	var tmp = document.getElementsByTagName("span");

	for (i = 0; i < tmp.length; i++) {

		if (tmp[i].className == "display_options") {

			var gw_id = tmp[i].getAttribute("data-gw");
			var opt = tmp[i].getAttribute("data-opt");

			var txt = "";
			
			switch (opt) {

				case "probe":		txt = (display_probe[gw_id] ? "hide" : "show") + " probe";			break;
				case "traffic":		txt = (display_traffic[gw_id] ? "hide" : "show") + " traffic";		break;
			
			}

			tmp[i].innerHTML = txt;
		
		}

	}

}

function toggle_display_option(gw_id, option) {

	switch (option)	{

		case "probe":		var opt = display_probe[gw_id] = !display_probe[gw_id];			break;
		case "traffic":		var opt = display_traffic[gw_id] = !display_traffic[gw_id];		break;
	
	}

	update_display_options();
	commit_display_options();

}

function commit_display_options() {

	for (i in display_probe) {

		if (display_probe[i])
			$("#gw_" + i + "_probe").slideDown();
		else
			$("#gw_" + i + "_probe").slideUp();

		
		if (display_traffic[i])
			$("#gw_" + i + "_traffic").slideDown();
		else
			$("#gw_" + i + "_traffic").slideUp();

	}

}

function new_xmlhttprequest() {

    if (window.XMLHttpRequest) {

		try {
		
			ret = new XMLHttpRequest();

		} catch (e) {

			throw "cannot instanciate XMLHttpRequest object: " + e;

		}

    } else if (window.ActiveXObject) {

		try {
        
			ret = new ActiveXObject("Msxml2.XMLHTTP");

		} catch (e) {

			try {

				ret = new ActiveXObject("Microsoft.XMLHTTP");

			} catch (e) {

				throw "cannot instanciate ActiveX XMLHTTP object: " + e;

			}

		}

	} else {

		throw "no XMLHttpRequest available";

	}

	return ret;

}


function update_values() {

	try	{

		xhr = new_xmlhttprequest();
		xhr.onreadystatechange = on_ajax_response;
		xhr.open("GET", "data_ajax.php", true);
		xhr.send();

	} catch (e) {

		handle_error(e);
	
	}
	
}

function update_content(id, content) {

	document.getElementById(id).innerHTML = content;
	
}

function update_class(id, cname) {

	document.getElementById(id).className = "value " + cname;

}

function update_probe_graph(gw_id) {

	if (!display_probe[gw_id])
		return false;
	
	var options = {
		color: "#aaf",
		legend: { position: "nw", margin: 0, backgroundOpacity: 0.75 },
		lines: { show: true, fill: true },
		points: { show: false },
		xaxis: { mode: "time", minTickSize: [1, "minute"] },
		yaxis: { min: 0, tickDecimals: 1 },
		y2axis: { min: 0, max: 100, tickFormatter: function (v, axis) { return v + "%" }},
		grid: {
				color: "#aaa",
				tickColor: "rgba(0,0,0,0.15)",
				labelMargin: 5,
				borderWidth: 2,
				borderColor: "#555",
		}
	};

	$.plot($("#graph_latency_" + gw_id), [	{ data: gwstats[gw_id].latency, label: "latency (ms)", color: "#ff9" },
											{ data: gwstats[gw_id].loss, label: "loss+err (%)", color: "#f99", yaxis: 2 }
										], options);

}

function update_traffic_graph(gw_id) {

	if (!display_traffic[gw_id])
		return false;
	
	var options = {
		color: "#aaf",
		legend: { position: "nw", margin: 0, backgroundOpacity: 0.75 },
		lines: { show: true, fill: true },
		points: { show: false },
		xaxis: { mode: "time", minTickSize: [1, "minute"] },
		yaxis: { min: 0, tickDecimals: 1, tickFormatter: function (v, axis) {
			if (v >= 1099511627776)
				return (v / 1099511627776).toPrecision(3) + "T";
			else if (v >= 1073741824)
				return (v / 1073741824).toPrecision(3) + "G";
			else if (v >= 1048576)
				return (v / 1048576).toPrecision(3) + "M";
			else if (v >= 1024)
				return (v / 1024).toPrecision(3) + "K";
			else
				return v + "B";
		}},
		grid: {
				color: "#aaa",
				tickColor: "rgba(0,0,0,0.15)",
				labelMargin: 5,
				borderWidth: 2,
				borderColor: "#555",
		}
	};

	$.plot($("#graph_traffic_" + gw_id), [	{ data: gwstats[gw_id].traffic_in, label: "inbound", color: "#9f9" },
											{ data: gwstats[gw_id].traffic_out, label: "outbound", color: "#99f" }
										], options);

}

function on_ajax_response() {

	if (xhr.readyState == 4) {

		if (xhr.status == 200) {

			mpdata = xhr.responseXML.getElementsByTagName("mpathdata")[0];
			
			// Update graphs

			tmp = new Date();
			time = tmp.getTime() - (tmp.getTimezoneOffset() * 1000 * 60);
			
			data = mpdata.getElementsByTagName("data");

			for (i = 0; i < data.length; i++) {

				var gw_id = data[i].getAttribute("gw");
				var data_id = data[i].getAttribute("id");
				var data_value = (data[i].textContent != null) ? data[i].textContent : data[i].text;
				
				if (gwstats[gw_id] == null)
					gwstats[gw_id] = [];

				if (gwstats[gw_id][data_id] == null)
					gwstats[gw_id][data_id] = [];

				gwstats[gw_id][data_id].push([time, data_value]);

				if (gwstats[gw_id][data_id].length > 250)
					gwstats[gw_id][data_id].shift();

			}
			
			for (var i in gwstats) {

				update_probe_graph(i);

				if (gwstats[i].traffic_in != null)
					update_traffic_graph(i);

			}
			
			// Update DOM
			
			values = mpdata.getElementsByTagName("value");
			
			for (i = 0; i < values.length; i++) {

				update_content(values[i].getAttribute("id"), (values[i].textContent != null) ? values[i].textContent : values[i].text);

				if (cname = values[i].getAttribute("class"))
					update_class(values[i].getAttribute("id"), cname);					

			}
			
			setTimeout(update_values, 1000);

		}

	}

}

function handle_error(str) {

	alert("error: " + str);

}

window.onload = mp_init;